/**
 * @package css-modules-types-loader
 * @license MIT
 * @version 0.4.0
 * @author nuintun <nuintun@qq.com>
 * @description A webpack loader that dynamically generates TypeScript typings for CSS modules from css-loader.
 * @see https://github.com/nuintun/css-modules-types-loader#readme
 */

'use strict';

const threads = require('threads');
const utils = require('./utils.cjs');
const promises = require('fs/promises');

/**
 * @module generate
 */
threads.expose(function generate(path, content, { banner, eol } = {}) {
  const typings = utils.generateTypings(content, banner, eol);
  if (typings) {
    return promises.writeFile(path, typings);
  }
  return promises.rm(path);
});
