/**
 * @package css-modules-types-loader
 * @license MIT
 * @version 0.4.0
 * @author nuintun <nuintun@qq.com>
 * @description A webpack loader that dynamically generates TypeScript typings for CSS modules from css-loader.
 * @see https://github.com/nuintun/css-modules-types-loader#readme
 */

import { expose } from 'threads';
import { generateTypings } from './utils.js';
import { writeFile, rm } from 'fs/promises';

/**
 * @module generate
 */
expose(function generate(path, content, { banner, eol } = {}) {
  const typings = generateTypings(content, banner, eol);
  if (typings) {
    return writeFile(path, typings);
  }
  return rm(path);
});
